#!/usr/bin/env node
'use strict';

require('module-alias/register');
const commander = require('commander');

require('../lib/util-commands/generate-lwa-tokens').createCommand(commander);

commander
    .usage('\n\n  $ ask util [command]')
    .description('Util functions to manage the life cycle of Alexa Skills.')
    .parse(process.argv);

if (!process.argv.slice(2).length) {
    commander.outputHelp();
} else {
    const UTIL_COMMAND_LIST = [
        'generate-lwa-tokens'
    ];
    if (UTIL_COMMAND_LIST.indexOf(process.argv[2]) === -1) {
        console.log('Command not recognized. Please run "ask util" for help.');
    }
}
