const querystring = require('querystring');

const CONSTANTS = require('@src/utils/constants');

const EMPTY_HEADERS = {};
const EMPTY_QUERY_PARAMS = {};
const NULL_PAYLOAD = null;

module.exports = (smapiHandle) => {
    function getUtteranceData(skillId, queryParameters, callback) {
        const url = `skills/${skillId}/history/intentRequests?${querystring.stringify(queryParameters)}`;
        smapiHandle(
            CONSTANTS.COMMAND.NAME.GET_UTTERANCE_DATA,
            CONSTANTS.HTTP_REQUEST.VERB.GET,
            CONSTANTS.SMAPI.VERSION.V1,
            url,
            EMPTY_QUERY_PARAMS,
            EMPTY_HEADERS,
            NULL_PAYLOAD,
            callback
        );
    }

    return {
        getUtteranceData
    };
};
