const CONSTANTS = require('@src/utils/constants');

module.exports = {
    REQUEST_ASK_PROFILE_NAME: [{
        message: `Please provide a profile name or press enter to use ${CONSTANTS.COMMAND.INIT.ASK_DEFAULT_PROFILE_NAME} as the profile name: `,
        type: 'input',
        name: 'profile',
        default: CONSTANTS.COMMAND.INIT.ASK_DEFAULT_PROFILE_NAME
    }],
    SELECT_VENDOR_ID: [{
        type: 'rawlist',
        message: 'Your Amazon developer account has multiple Vendor IDs. Please choose the Vendor ID for the skills you want to manage.',
        name: 'selectedVendor'
    }],
    CREATE_NEW_OR_OVERRIDE: [{
        type: 'list',
        message: 'Please create a new profile or overwrite the existing profile.\n',
        name: 'profile'
    }],
    REQUEST_AWS_PROFILE_NAME: [{
        type: 'input',
        name: 'awsProfileName',
        message: `Please provide a profile name or press enter to use ${CONSTANTS.COMMAND.INIT.AWS_DEFAULT_PROFILE_NAME} as the profile name: `,
        default: CONSTANTS.COMMAND.INIT.AWS_DEFAULT_PROFILE_NAME
    }],
    CONFIRM_OVERRIDING_PROFILE: [{
        type: 'confirm',
        name: 'overwrite',
        default: true
    }],
    USE_ENVIRONMENT_VARIABLES: [{
        message: 'We have detected you have AWS environment variables. Would you like to setup your profile using those?',
        type: 'list',
        name: 'choice',
        choices: ['Yes', 'No']
    }],
    SET_UP_AWS_PROFILE: [{
        message: 'If you want to host your skill\'s backend code in AWS Lambda (recommended), you must associate an AWS profile with the ASK CLI. '
        + 'Do you want to associate an AWS profile?',
        type: 'confirm',
        name: 'choice',
        default: true
    }],
    SELECT_OR_CREATE_AWS_PROFILE: [{
        type: 'list',
        name: 'chosenProfile',
        message: 'Please choose from the following existing AWS profiles or create a new one.'
    }],
    REQUEST_ACCESS_SECRET_KEY_AND_ID: [
        {
            type: 'input',
            name: 'accessKeyId',
            message: 'AWS Access Key ID: ',
            validate(input) {
                if (!input.trim()) {
                    return '"AWS Access Key ID" cannot be empty.';
                }
                return true;
            }
        },
        {
            type: 'input',
            name: 'secretAccessKey',
            message: 'AWS Secret Access Key: ',
            validate(input) {
                if (!input.trim()) {
                    return '"AWS Secret Access Key" cannot be empty.';
                }
                return true;
            }
        }
    ]
};
