const CONSTANTS = require('../../utils/constants');
const handler = require('./handler');

// Public
module.exports = {
    createCommand: (commander) => {
        commander
            .command('new')
            .description('create a new skill project on your computer')
            .option('-n, --skill-name <name>', 'create new skill project with skill name')
            .option('--template <template-name>', 'generate a skill package locally with template name')
            .option('--url <url>', 'the url to the template list or the git repo')
            .option('--lambda-name <lambda-name>', 'define lambda name if the skill needs lambda function')
            .option('-p, --profile <profile>', 'ask cli profile')
            .option('--debug', 'ask cli debug mode')
            .option('-h, --help', 'output usage information', () => {
                console.log(CONSTANTS.COMMAND.NEW.HELP_DESCRIPTION);
                process.exit(0);
            })
            .action(handler.handleOptions);
    }
};
