'use strict';

const CONSTANTS = require('../utils/constants');

module.exports = {
    isErrorMessageSkippable: isErrorMessageSkippable
};

function isErrorMessageSkippable(errMessage) {
    if (errMessage === CONSTANTS.DIFF.ERROR_MESSAGE.MODEL_STATUS_IN_PROGRESS ||
        errMessage === CONSTANTS.DIFF.ERROR_MESSAGE.SKILL_STATUS_IN_PROGRESS ||
        errMessage === CONSTANTS.DIFF.ERROR_MESSAGE.MODEL_STATUS_NOT_EXIST) {
        return true;
    }

    if (errMessage.startsWith(CONSTANTS.DIFF.ERROR_MESSAGE.LAMBDA_GET_FAILED)) {
        return true;
    }

    return false;
}
