'use strict';

const Promise = require('bluebird');

module.exports = {
    promiseWhile: promiseWhile
}

function promiseWhile(condition, action) {
    return new Promise(function(resolve, reject) {
        const loop = function() {
            if (!condition()) {
                resolve();
            } else {
                Promise.cast(action())
                       .then(loop)
                       .catch(reject);
            }
        }
        process.nextTick(loop);
    });
};