'use strict';

const request = require('request');
const tools = require('../utils/tools');

module.exports = {
    requestPublicUrl: requestPublicUrl
};

/**
 * Wrapper function to request content from a public URL
 * @param url
 * @param callback
 */
function requestPublicUrl(url, callback) {
    if (!url) {
        callback('URL cannot be null or empty.');
    }
    const ENDPOINT = url;
    let headers = {};
    headers['User-Agent'] = 'ask-cli/' + require('../../package.json').version + '  Node/' + process.version;

    let params = {
        url: ENDPOINT,
        method: 'GET',
        headers: headers
    };

    request(params, (error, response) => {
        if (error || !response.statusCode || !response.body) {
            callback(error ? error : 'Response received is null');
            return;
        }
        let responseBodyJsonObject = tools.convertDataToJsonObject(response.body);
        callback(null, responseBodyJsonObject);
    });
}