'use strict';
const constants = require('./constants');
const message = require('./messages');

// Public function name
module.exports = {
    getSkillID: getSkillID,
    getSkillName: getSkillNameFromCloneResponse,
    getListVendorID: getListVendorID
}

/**
 * Find skill id from input string.
 * This is use for parsing create/update skill or deploy output string to find skill id
 * @param {String} output
 */
function getSkillID(output){
    output = output.toLowerCase();
    output = output.split(constants.paramValue.SKILL_ID).pop()
    return output.split(/\r?\n/)[0];
}

/**
 * Find skill name from input string.
 * This is use for parsing clone output string to find folder name
 * @param {String} output
 */
function getSkillNameFromCloneResponse(output){
    output = output.split(message.CLONE_SKILL_MSG).pop()
    return output.split(' ')[0];
}

/**
 * Get list of vendor id from input string.
 * This is use for parsing list-vendors output string to find the list of vendor id that profile owns
 * @param {String} output
 */
function getListVendorID(getListVendorsResponse){
    return JSON.parse(getListVendorsResponse).map((vendorInfo) => {
        return vendorInfo['id'];
      });
}