'use strict';

require('module-alias/register');

/**
 * This list manages all the files we want to cover during the refactor.
 * Please also include the test-ready module in package.json's "nyc.include" list.
 * Make sure test coverage meets the bar.
 */
[
    '@test/unit/api/api-wrapper-test.js',
    '@test/unit/clients/http-client-test',
    '@test/unit/clients/smapi-client-test',
    '@test/unit/clients/git-client-test',
    '@test/unit/utils/url-utils-test',
    '@test/unit/commands/new/ui-test',
    '@test/unit/commands/new/handler-test',
    '@test/unit/commands/new/helper-test',
    '@test/unit/utils/hook-manager-test',
    '@test/unit/commands/option-validator-test',
].forEach(testFile => {
    require(testFile);
});